<?php

namespace App\Controllers;

use Dynamite\DatabaseTable as DB;

use Dynamite\Controller;



class AlumnoController extends Controller

{

	private $session;

	private $config;

	private $auth;

	private $tablaAC;

	private $tablaUsuarios;

	private $helper;



	function __construct(\Dynamite\Authentication $auth, DB $tablaAC, DB $tablaUsuarios)

	{

		$this->session = new \Dynamite\Session;

		$this->config = new \Config\Configuration;

		$this->tablaAC = $tablaAC;

		$this->tablaUsuarios = $tablaUsuarios;

		$this->auth = $auth;

		$this->helper = new \Dynamite\Helper($this->auth, $this->session, $this->config);

	}



	/*public function misClases() {

		$usuario = $this->auth->getUser();

		$clases = $this->tablaAC->find('idAlumno', $usuario->id);
		
		$alumno = $this->tablaUsuarios->find('id', $usuario->id);
		$alumnA = array();
		foreach ($alumno as $idAlumn) {
				if ($idAlumn->id == $usuario->id) {
					$alumnA[] = $idAlumn;
				}
			}

		return [

			'template' => 'content/alumno/misClases',

			'title' => 'Mis Clases',

			'variables' => [

				'clases' => $clases,
				'alumno' => $alumnA,

			]

		];

	}*/
	
	public function misClases() {

		$usuario = $this->auth->getUser();

		$clases = $this->tablaAC->find('idAlumno', $usuario->id);
		$alumno = $this->tablaUsuarios->find('id', $usuario->id);
		return [

			'template' => 'content/alumno/misClases',

			'title' => 'Mis Clases',

			'variables' => [

				'clases' => $clases,
				'alumno' => $alumno,

			]

		];

	}

	public function kardex() {

		$dompdf = new \Dompdf\Dompdf();

		$dompdf->set_option('enable_remote', TRUE);

		$dompdf->set_option('enable_css_float', TRUE);

		$dompdf->set_option('enable_html5_parser', FALSE);

		$route = 'content/alumno/kardex';

		$usuario = $this->auth->getUser();

		$id = $_GET['id'];

		if($usuario->esDelTipoUsuario(\App\Entity\Usuario::ALUMNO) && $id != $usuario->id) {

			$this->session->flash('error', 'No tienes permiso para ver ese kardex');

			header('location: ./mis-clases/');

			return;

		}

		$kardex = $this->tablaAC->find('idAlumno', $id);

		$alumno = $this->tablaUsuarios->findById($id);

			if($usuario->esDelTipoUsuario(\App\Entity\Usuario::ALUMNO)) {

				$admin = false;

			} else {

				$admin = true;

			}

			$output = $this->helper->renderView($route, [

				'kardex' => $kardex ?? [],

				'alumno' => $alumno,

				'isAdmin' => $admin

			]);

			$dompdf->load_html($output);

			$dompdf->render();

			$dompdf->stream("kardex.pdf", array("Attachment" => false));

			return [

				'jsonResponse' => true

			];

	}

}