<?php

namespace App\Controllers;

use Dynamite\DatabaseTable as DB;

use Dynamite\Controller;



class App extends Controller

{

	private $session;

	private $auth;

	private $tablaUsuarios;



	function __construct(\Dynamite\Authentication $auth, DB $tablaUsuarios)

	{

		$this->session = new \Dynamite\Session;

		$this->auth = $auth;

		$this->tablaUsuarios = $tablaUsuarios;

	}



	public function err404() {

		return [

			'template' => 'error/404',

			'layout' => 'layoutLogin',

			'title' => '404'

		];	

	}



	public function index($variables = []) {

		return [

			'template' => 'content/login/index',

			'layout' => 'layoutLogin',

			'title' => 'Ingresar',

			'variables' => $variables

		];

	}



	public function dashboard() {

		$user = $this->auth->getUser();

		if($user->esDelTipoUsuario(\App\Entity\Usuario::ADMINISTRADOR)) {

			header('location: ./alumnos/');

			return;

		} else if($user->esDelTipoUsuario(\App\Entity\Usuario::PROFESOR)) {

			header('location: ./clases/');

			return;

		} else if($user->esDelTipoUsuario(\App\Entity\Usuario::DIRECTOR)) {

			header('location: ./licenciaturas/');

			return;

		} else if($user->esDelTipoUsuario(\App\Entity\Usuario::ALUMNO)) {

			header('location: ./mis-clases/');

			return;

		}

	}



	public function processLogin() {

		$user = $_POST['usuario'];

		$required = ['credencial', 'password'];

		$errors = $this->validate($user, $required);

		if (empty($errors)) {

			$usuario = $this->tablaUsuarios->find('correo', $user['credencial']);

			if(count($usuario) == 0) {

				$usuario = $this->tablaUsuarios->find('matricula', $user['credencial']);

			}

			if(count($usuario) == 0) {

				$usuario = $this->tablaUsuarios->find('usuario', $user['credencial']);

			}

			if(count($usuario) > 0) {

				$usuario = $usuario[0];

				$correo = $usuario->correo;

				if($this->auth->login($correo, $user['password'])) {

					$loggedUser = $this->auth->getUser();

					// if($loggedUser->estado == 'inactivo') {

					// 	$this->session->logout();

					// 	$this->session->flash('error', 'Cuenta suspendida, contacta al administrador');

					// 	header('location: ./');

					// 	return;

					// }

					header('location: ./panel/');

					return;

				} else {

					$this->session->flash('error', 'Las credenciales son incorrectas');

					header('location: ./');

					return;

				}

			} else {

				$this->session->flash('error', 'No existe el usuario.');

				header('location: ./');

				return;

			}

		}



		return $this->index([

			'old' => $user,

			'errors' => $errors

		]);

	}



	public function logout() {

		$this->session->logout();

		header('location: ./');

		return;

	}

}