<?php

namespace App\Controllers;

use Dynamite\DatabaseTable as DB;

use Dynamite\Controller;



class PEController extends Controller

{

	private $session;

	private $tablaPE;



	function __construct(DB $tablaPE)

	{

		$this->session = new \Dynamite\Session;

		$this->tablaPE = $tablaPE;

	}



	public function changeStatus() {

		$id = $_POST['id'] ?? 0;

		$lic = $this->tablaPE->findById($id);

		if($lic){

			if($lic->estado == 'activo') {

				$newStatus = 'inactivo';

			} else {

				$newStatus = 'activo';

			}

			$this->tablaPE->save([

				'id' => $id,

				'estado' => $newStatus

			]);

			$this->session->flash('warning', 'Se cambió el estado de el Periodo Escolar.');

			header('location: ./');

			return;

		}

		$this->session->flash('error', 'No existe el Periodo Escolar a el que se le quiere cambiar el estado.');

		header('location: ./');

		return;

	}



	public function index() {

		$pe = $this->tablaPE->findAll();

		return [

			'template' => 'content/periodos/index',

			'title' => 'Periodos Escolares - Inicio',

			'variables' => [
				'periodos' => $pe,
			]

		];

	}



	public function create($variables = []) {

		return [

			'template' => 'content/periodos/create',

			'title' => 'Periodos Escolares - Crear',

			'variables' => $variables

		];

	}



	public function store() {

		$data = $this->storeUpdate();

		if(!is_array($data)) {

			$this->session->flash('info', 'Se creó el Periodo Escolar.');

			header('location: ./');

			return;

		}

		$this->session->flash('error', 'No se pudo crear el Periodo Escolar.');

		return $this->create(['errors' => $data, 'old' => $_POST['periodo']]);

	}



	public function edit($variables = []) {

		$id = $_GET['id'];

		$periodo = $this->tablaPE->findById($id);

		$periodo->fechaInicio = date('Y-m-d', strtotime($periodo->fechaInicio));

		$periodo->fechaFinal = date('Y-m-d', strtotime($periodo->fechaFinal));

		$variables['periodo'] = $periodo;

		return [

			'template' => 'content/periodos/edit',

			'title' => 'Periodos Escolares - Editar',

			'variables' => $variables

		];

	}



	public function update() {

		$data = $this->storeUpdate(true);

		if(!is_array($data)) {

			$this->session->flash('info', 'Se actualizó el Periodo Escolar.');

			header('location: ./');

			return;

		}

		$this->session->flash('error', 'No se pudo actualizar el Periodo Escolar.');

		return $this->edit(['errors' => $data, 'old' => $_POST['periodo']]);

	}



	public function storeUpdate($edit = false) {

		$data = $_POST['periodo'];

		$required = ['nombre', 'fechaInicio', 'fechaFinal'];

		$errors = $this->validate($data, $required);

		if(empty($errors)) {

			$this->tablaPE->save($data);

			return true;

		}

		return $errors;

	}

}