<?php

namespace App\Controllers;

use Dynamite\DatabaseTable as DB;

use Dynamite\Controller;



class Pagos extends Controller

{

	private $session;

	private $tablaMaterias;



	function __construct(DB $tablaPagos)

	{

		$this->session = new \Dynamite\Session;

		$this->tablaPagos = $tablaPagos;

	}



	public function index() {

		$pagos = $this->tablaPagos->findAll();
		return [

			'template' => 'content/pagos/index',

			'title' => 'Pagos - Index',

			'variables' => [

				'pagos' => $pagos,
			]

		];

	}



	public function create($variables = []) {

		return [

			'template' => 'content/materias/create',

			'title' => 'Materias - Crear',

			'variables' => $variables

		];

	}



	public function store() {

		$data = $this->storeUpdate();

		if(!is_array($data)) {

			$this->session->flash('info', 'Se creó la materia.');

			header('location: ./');

			return;

		}

		$this->session->flash('error', 'No se pudo registrar la materia.');

		return $this->create(['errors' => $data, 'old' => $_POST['materia'] ?? null]);

	}



	public function edit($variables = []) {

		$id = $_GET['id'];

		$materia = $this->tablaMaterias->findById($id);

		$variables['materia'] = $materia;

		return [

			'template' => 'content/materias/edit',

			'title' => 'Materias - Editar',

			'variables' => $variables

		];

	}



	public function update() {

		$data = $this->storeUpdate(true);

		if(!is_array($data)) {

			$this->session->flash('info', 'Se actualizó la materia.');

			header('location: ./');

			return;

		}

		$this->session->flash('error', 'No se pudo actualizar la materia.');

		return $this->edit(['errors' => $data, 'old' => $_POST['materia'] ?? null]);

	}



	public function storeUpdate($edit = false) {

		$data = $_POST['materia'];

		$required = ['nombre', 'clave'];

		$errors = $this->validate($data, $required);

		if(empty($errors)) {

			if(!$edit){

				$data['fechaRegistro'] = date('Y-m-d H:i:s');

			}

			$this->tablaMaterias->save($data);

			return true;

		}

		return $errors;

	}

}