<?php

namespace App\Entity;



class Clase {

	public $id;

	public $idMateria;

	public $idProfesor;

	public $idPeriodoEscolar;

	public $nombre;

	public $descripcion;

	public $nota;

	public $estado;

	public $fechaRegistro;

	private $tablaMaterias;

	private $tablaUsuarios;

	private $tablaPE;

	private $tablaAlumnoClase;



	public function __construct(\Dynamite\DatabaseTable $tablaMaterias, \Dynamite\DatabaseTable $tablaUsuarios, \Dynamite\DatabaseTable $tablaPE, \Dynamite\DatabaseTable $tablaAlumnoClase) {

		$this->tablaMaterias = $tablaMaterias;

		$this->tablaUsuarios = $tablaUsuarios;

		$this->tablaPE = $tablaPE;

		$this->tablaAlumnoClase = $tablaAlumnoClase;

	}



	public function materia() {

		return $this->tablaMaterias->findById($this->idMateria);

	}



	public function profesor() {

		return $this->tablaUsuarios->findByid($this->idProfesor);

	}



	public function periodo() {

		return $this->tablaPE->findByid($this->idPeriodoEscolar);

	}



	public function alumnos() {

		$alumnosClase = $this->tablaAlumnoClase->find('idClase', $this->id);

		$alumnos = [];

		foreach ($alumnosClase as $ac) {

			$alumnos[] = $ac->alumno();

		}

		return $alumnos;

	}

}