<?php

namespace App\Entity;



class Usuario {

	const ALUMNO = 'alumno';

	const PROFESOR = 'profesor';

	const ADMINISTRADOR = 'administrador';

	const DIRECTOR = 'director';



	public $id;

	public $estado;
	public $curp;
	public $calle;
	public $no_exterior;
	public $no_interior;
	public $colonia;
	public $cp;
	public $pais;
	public $dom_estado;

	public $nombre;

	public $apellido;

	public $matricula;

	public $referenciaBancaria;

	public $modalidad;

	public $idLicenciatura;

	public $correo;

	public $telefono;

	public $password;

	public $tipo_usuario;

	public $usuario;

	public $fechaRegistro;
	public $fechaSICYT;

	private $tablaClases;

	private $tablaAlumnoClase;

	private $tablaLicenciaturas;
	private $tablaMensajes;




	public function __construct(\Dynamite\DatabaseTable $tablaClases, \Dynamite\DatabaseTable $tablaAlumnoClase, \Dynamite\DatabaseTable $tablaLicenciaturas, \Dynamite\DatabaseTable $tablaMensajes) {

		$this->tablaClases = $tablaClases;

		$this->tablaAlumnoClase = $tablaAlumnoClase;

		$this->tablaLicenciaturas = $tablaLicenciaturas;
		$this->tablaMensajes = $tablaMensajes;

	}



	public function esDelTipoUsuario($tipoUsuario) {

		return $this->tipo_usuario == $tipoUsuario;

	}



	public function licenciatura() {

		return $this->tablaLicenciaturas->findById($this->idLicenciatura);

	}



	public function clases() {

		if($this->tipo_usuario == $this->PROFESOR) {

			return $this->tablaClases->find('idProfesor', $this->id);

		} else if($this->tipo_usuario == $this->ALUMNO) {

			$alumnoClase = $this->tablaAlumnoClase->find('idAlumno', $this->id);

			$clases = [];

			foreach ($alumnoClase as $ac) {

				$clases[] = $ac->clase();

			}

			return $clases;

		}

		return null;

	}

	public function cursarClase($idMateria) {
		$alClases = $this->tablaAlumnoClase->find('idAlumno', $this->id);
		foreach ($alClases as $alClase) {
			$clase = $alClase->clase();
			if ($clase->idMateria == $idMateria) {
				if ($alClase->calificacion >= 6.0) {
					return false;
				}
			}
		}
		return true;
	}

	public function claseLicenciatura($idMateria)
	{
		$lic = $this->tablaLicenciaturas->findByid($this->idLicenciatura);
		return $lic->materiaPertenece($idMateria);
	}

	public function clasesCursadas() {
		$alClases = $this->tablaAlumnoClase->find('idAlumno', $this->id);
		$total = 0;
		foreach ($alClases as $alClase) {
			$clase = $alClase->clase();
			if ($alClase->calificacion >= 6.0) {
				$total++;
			}
		}
		return $total;
	}
	
	public function clasesCursadasA() {
		$alClases = $this->tablaAlumnoClase->find('idAlumno', $this->id);
		$total = 0;
		foreach ($alClases as $alClase) {
			$clase = $alClase->clase();
			if ($alClase->calificacion >= 1.0) {
				$total++;
			}
		}
		return $total;
	}
	
	public function promedio() {
		$alClases = $this->tablaAlumnoClase->find('idAlumno', $this->id);
		$promedio =0;
		$total = 0;
		$resultado = 0;
		foreach ($alClases as $alClase) {
			$clase = $alClase->clase();
			if ($alClase->calificacion >= 1.0) {
				$califa = $alClase->calificacion;
				$promedio= $promedio + $califa;
				$total++;
			}
		}
		if ($total == 0):
			$resultado = 0;
		else:
			$resultado = $promedio / $total;
		endif;
		return round($resultado, 1);
	}

	public function getMessages()
	{
		return $this->tablaMensajes->find('id_usuario_recibe', $this->id, 'fecha desc', 10);
	}

}