<?php

namespace Dynamite;



class Helper {

	private $auth;

	private $session;

	private $config;

	private $route;

	private $extendsContent;

	private $actualContent;

	private $extendsFileName;

	private $extendsVariables;



	public function __construct(\Dynamite\Authentication $auth, \Dynamite\Session $session, $config, $route = '') {

		$this->auth = $auth;

		$this->session = $session;

		$this->config = $config;

		$this->route = $route;

		$this->extendsContent = [];

		$this->actualContent = false;

		$this->extendsFileName = '';

		$this->extendsVariables = [];

	}



	public function renderView($fileName, $variables = []) {

		$variables['_route'] = $this->config->routeRelative;

		$variables['_totalRoute'] = $this->config->route;

		extract($variables);

		ob_start();

		if(file_exists(__DIR__ . '/../templates/' . $fileName . '.php')) {

			include __DIR__ . '/../templates/' . $fileName . '.php';

		} else if(file_exists(__DIR__ . '/../templates/' . $fileName . '.html.php')) {

			include __DIR__ . '/../templates/' . $fileName . '.html.php';

		} else {

			include __DIR__ . '/../templates/' . $fileName;

		}



		return ob_get_clean();

	}



	public function include($fileName, $variables = []) {

		$variables['_route'] = $this->config->routeRelative;

		$variables['_totalRoute'] = $this->config->route;

		$variables['_thisRoute'] = $this->route;

		$variables['session'] = $this->session;

		$variables['auth'] = $this->auth->getUser() ?? false;

		$variables['helper'] = $this;

		extract($variables);

		ob_start();

		if(file_exists(__DIR__ . '/../templates/' . $fileName . '.php')) {

			include __DIR__ . '/../templates/' . $fileName . '.php';

		} else if(file_exists(__DIR__ . '/../templates/' . $fileName . '.html.php')) {

			include __DIR__ . '/../templates/' . $fileName . '.html.php';

		} else {

			include __DIR__ . '/../templates/' . $fileName;

		}



		return ob_get_clean();

	}



	public function extends($fileName, $variables = []) {

		if($this->extendsFileName == '') {

			$this->extendsFileName = $fileName;

			$this->extendsVariables = $variables;

			return true;

		}

		return false;

	}



	public function endExtends() {

		$this->extendsVariables['_route'] = $this->config->routeRelative;

		$this->extendsVariables['_thisRoute'] = $this->route;

		$this->extendsVariables['session'] = $this->session;

		$this->extendsVariables['auth'] = $this->auth->getUser() ?? false;

		$this->extendsVariables['helper'] = $this;

		extract($this->extendsVariables);

		unset($this->extendsVariables);

		extract($this->extendsContent);

		unset($this->extendsContent);

		ob_start();

		if(file_exists(__DIR__ . '/../templates/' . $this->extendsFileName . '.php')) {

			include __DIR__ . '/../templates/' . $this->extendsFileName . '.php';

		} else if(file_exists(__DIR__ . '/../templates/' . $this->extendsFileName . '.html.php')) {

			include __DIR__ . '/../templates/' . $this->extendsFileName . '.html.php';

		} else {

			include __DIR__ . '/../templates/' . $this->extendsFileName;

		}

		echo ob_get_clean();

		return true;

	}



	public function content($contentName) {

		if(!$this->actualContent) {

			$this->actualContent = $contentName;

			ob_start();

			return true;

		}

		return false;

	}



	public function endContent() {

		$tempContent = ob_get_clean();

		if($this->actualContent) {

			$this->extendsContent[$this->actualContent] = $tempContent;

			$this->actualContent = false;

			return true;

		}

		return false;

	}

}