<?php

namespace Dynamite;



class Session {



	private $active;



	public function __construct() {

		$this->active = '';

	}



	public function start() {

		session_start();

	}



	public function exists(string $active) {

		if(isset($_SESSION[$active])) {

			$this->active = $active;

			return $this;

		}

		return false;

	}



	public function isset(string $name) {

		if(isset($_SESSION[$this->active][$name])) {

			return $this;

		}

		return false;

	}



	public function set(string $own) {

		$this->active = $own;

		return $this;

	}

	

	public function unset() {

		$this->active = '';

		return $this;

	}



	public function flash(string $name, string $text) {

		$this->active = 'flash';

		$_SESSION['flash'][$name] = $text;

		return $this;

	}



	public function destroy(string $active) {

		unset($_SESSION[$active]);

		return $this;

	}



	public function get($name) {

		if(isset($_SESSION[$this->active][$name])) {

			$tempSession = $_SESSION[$this->active][$name];

			if($this->active == 'flash') {

				unset($_SESSION['flash'][$name]);

				if(empty($_SESSION['flash'])) {

					unset($_SESSION['flash']);

				}

			}

			return $tempSession;

		}

		return false;

	}



	public function login($username, $password) {

		session_regenerate_id();

		$_SESSION['username'] = $username;

		$_SESSION['password'] = $password;

		return;

	}



	public function logout() {

		unset($_SESSION);

		session_destroy();

		session_start();

		session_regenerate_id();

	}



}