<?php $helper->extends('content/partials/generalLayout', ['sectionTitle' => $sectionTitle]); ?>

<?php $helper->content('section') ?>

<div class="table-responsive">

	<table class="table-sm table table-striped table-bordered display" id="datatable">

		<thead>

			<tr>

				<th>Nombre(s)</th>

				<th>Apellido(s)</th>

				<th>Correo</th>

				<th>Telefono</th>

				<th>Fecha Registro</th>

				<th>Estado</th>

				<?php if($tipoUsuario == 'alumno'): ?>

				<th>Licenciatura</th>

				<th>Matrícula</th>

				<th>Alta SICyT</th>

				<th>Modalidad</th>

				<th>Documentación Faltante</th>

				<?php endif; ?>

				<th>Acciones</th>

			</tr>

		</thead>

		<tbody>

			<?php foreach($usuarios as $usuario): ?>

			<tr>

				<td><?php echo htmlspecialchars($usuario->nombre); ?></td>

				<td><?php echo htmlspecialchars($usuario->apellido); ?></td>

				<td><?php echo htmlspecialchars($usuario->correo); ?></td>

				<td><?php echo htmlspecialchars($usuario->telefono); ?></td>

				<td><?php echo date('Y-m-d' ,strtotime($usuario->fechaRegistro)); ?></td>

				<td><?php echo ucfirst($usuario->estado); ?></td>

				<?php if($tipoUsuario == 'alumno'): ?>

				<td><?php echo htmlspecialchars($usuario->licenciatura()->nombre); ?></td>

				<td><?php echo htmlspecialchars($usuario->matricula); ?></td>

				<td><?php echo htmlspecialchars($usuario->fechaSicyt); ?></td>

				<td><?php echo htmlspecialchars($usuario->modalidad); ?></td>
				<?php 
				$text = '';
				if ($usuario->url_acta_nacimiento == '') {
					$text .= '<span class="text-danger text-nowrap">ACTA DE NACIMIENTO</span><br>';
				}
				if ($usuario->url_certificado == '') {
					$text .= '<span class="text-danger text-nowrap">CERTIFICADO DE BACHILLERATO</span><br>';
				}
				if ($usuario->url_comprobante_dom == '') {
					$text .= '<span class="text-danger text-nowrap">COMPROBANTE DE DOMICILIO</span><br>';
				}
				if ($usuario->url_identificacion == '') {
					$text .= '<span class="text-danger text-nowrap">IDENTIFICACIÓN</span><br>';
				}

				 ?>
				<td><?php echo $text; ?></td>

				<?php endif; ?>

				<td>

					<div class="d-flex">

						<a href="./editar?id=<?php echo $usuario->id; ?>" title="Editar" class="btn btn-warning btn-sm me-2">Editar</a>

						<!-- <form class="me-2" method="POST" action="./estado">

							<input type="hidden" name="id" value="<?php  // echo $usuario->id; ?>">

							<button type="submit" class="btn btn-sm btn-secondary"><?php // echo $usuario->estado == 'activo' ? 'Inactivar' : 'Activar'; ?></button>

						</form> -->

						<?php if($tipoUsuario == \App\Entity\Usuario::ALUMNO): ?>

						<a href="<?php echo $_route.'panel/alumnos/pagos?id='.$usuario->id; ?>" class="btn btn-sm btn-light me-2">Pagos</a>

						<a target="_blank" href="<?php echo $_route.'panel/kardex?id='.$usuario->id; ?>" class="btn btn-sm btn-info">KARDEX</a>

						<a href="<?php echo $_route.'panel/documentos?id='.$usuario->id; ?>" class="btn btn-sm btn-info text-nowrap ms-2">VER DOCUMENTOS</a>
						<a href="<?php echo $_route.'panel/mensajes?id='.$usuario->id; ?>" class="btn btn-sm btn-info text-nowrap ms-2">MENSAJES</a>
						<a href="<?php echo $_route.'panel/fechas-titulacion?id='.$usuario->id; ?>" class="btn btn-sm btn-info text-nowrap ms-2">TITULACIÓN</a>
						<form class="me-2" method="POST" action="./servicio">

							<input type="hidden" name="id" value="<?php echo $usuario->id; ?>">

							<button type="submit" class="text-nowrap ms-2 btn btn-sm btn-secondary"><?php echo $usuario->servicio == 'no' ? 'Finalizar Servicio' : 'Iniciar Servicio Social'; ?></button>

						</form>
						<?php endif; ?>

					</div>

				</td>

			</tr>

			<?php endforeach; ?>

		</tbody>

	</table>

</div>

<?php $helper->endContent() ?>



<?php $helper->endExtends(); ?>